/* GGL - GPUL Game Library
 * Copyright (C) 1998 G.P.U.L. (Group of programmers and users of Linux)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GGLARBITER_H__
#define __GGLARBITER_H__

#include <glib.h>
#include <ggl/gglbase.h>
#include <ggl/ggldevice.h>
#include <ggl/gglsprite.h>

#define GGL_ARBITER(arbiter) (GGL_CAST (arbiter, GglArbiter*, GGLARBITER))

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct _GglArbiter GglArbiter;

struct _GglArbiter{
    GglDevice device;
    int id;
    GList *sprites;
    GList *deleted; /* We must take in account sprites that are deleted */
};


/* Constructors */
GglArbiter*	ggl_arbiter_new		(void);

void		ggl_arbiter_init	(GglArbiter *arbiter);

void		ggl_arbiter_dispose	(GglArbiter *arbiter);

void		ggl_arbiter_finalize	(GglArbiter *arbiter);

void            ggl_arbiter_listen      (GglArbiter *arbiter,
					 GglSprite *sprite);
void            ggl_arbiter_ignore      (GglArbiter *arbiter,
					 GglSprite *sprite);

#ifdef __cplusplus
      }
#endif /* __cplusplus */

#endif /* __GGLARBITER_H__ */
