/* GGL - GPUL Game Library
 * Copyright (C) 1998 G.P.U.L. (Group of programmers and users of Linux)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GGLCLIENT_H__
#define __GGLCLIENT_H__

#include <ggl/gglbase.h>

#define GGL_CLIENT(client) (GGL_CAST(client,GglClient*,GGLCLIENT))

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct _GglClient GglClient;

struct _GglClient{
  GglBase base;         /* Base class */
  int id;               /* Class Identifier */
};

/* Constructors */
GglClient *	ggl_client_new	(void);
void		ggl_client_init 	(GglClient *	client);
GglDescriptor *	ggl_client_add	(int	local_port,
				 char *	remote_IP,
				 int *	remote_port);
void            ggl_client_finalize	(GglClient *	client);
void            ggl_client_dispose	(GglClient *	client);
					
#ifdef __cplusplus
      }
#endif /* __cplusplus */

#endif /* __GGLCLIENT_H__ */

