/* GGL - GPUL Game Library
 * Copyright (C) 1998 G.P.U.L. (Group of programmers and users of Linux)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GGLMASK_H__
#define __GGLMASK_H__

#include <ggl/gglcolor.h>
#include <ggl/gglrectangle.h>

#define GGL_MASK(mask) (GGL_CAST(mask,GglMask*,GGLMASK))

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct _GglMask GglMask;

struct _GglMask{
  GglBase base;         /* Base class */
  int id;               /* Class Identifier */
  unsigned char *data;  /* RLE compressed data */
  unsigned int size;    /* The mask size */
  int width,height;     /* Width and height of the expanded mask */
  unsigned char **lines;/* Pointers to start of all lines in the mask */
};

/* Constructors */
GglMask* 	ggl_mask_new 	(GglVisual *visual,
				 GglColor *transparent);

void		ggl_mask_init	(GglMask *mask,
				 GglVisual *visual,
				 GglColor *transparent);

void		ggl_mask_dispose(GglMask *mask);

void		ggl_mask_finalize(GglMask *mask);

int 		ggl_mask_overlap
				(GglMask *mask1,
				 GglMask *mask2,
				 GglRectangle r1,
				 GglRectangle r2);

#ifdef __cplusplus
      }
#endif /* __cplusplus */

#endif /* __GGLMASK_H__ */
