/* GGL - GPUL Game Library
 * Copyright (C) 1998 G.P.U.L. (Group of programmers and users of Linux)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GGLMOUSEDEV_H__
#define __GGLMOUSEDEV_H__

#include <glib.h>
#include <ggl/gglbase.h>
#include <ggl/ggldevice.h>
#include <ggi/ggi.h>

#define GGL_MOUSEDEV(mousedev) (GGL_CAST(mousedev,GglMouseDev*,GGLMOUSEDEV))

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct _GglMouseDev GglMouseDev;

struct _GglMouseDev{
  GglDevice device;
  int id;
  GglVisual *visual; /* The visual on which we receive events */  
};

/* Constructors */
GglMouseDev*	ggl_mousedev_new		(GglVisual *visual);

void		ggl_mousedev_init		(GglMouseDev *mousedev,
					 GglVisual *visual);

void		ggl_mousedev_finalize	(GglMouseDev *mousedev);

void		ggl_mousedev_dispose	(GglMouseDev *mousedev);

#ifdef __cplusplus
      }
#endif /* __cplusplus */

#endif /* __GGLMOUSEDEV_H__ */
