/* GGL - GPUL Game Library
 * Copyright (C) 1998 G.P.U.L. (Group of programmers and users of Linux)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GGLNETWORK_H__
#define __GGLNETWORK_H__

#include <ggl/gglbase.h>
#include <glib.h>

#define GGL_NETWORK(network) (GGL_CAST(network,GglNetwork*,GGLNETWORK))

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct _GglNetwork GglNetwork;

struct _GglNetwork{
  GglBase base;         /* Base class */
  int id;               /* Class Identifier */

  int status;		/* Internal status */
  Glist *socket_list;	/* List of active sockets */
  char local_IP;	/* Local IP of this machine */
};

/* Constructors */
GglNetwork *	ggl_network_new		(void);
void		ggl_network_init	(GglNetwork *	network);
void 		ggl_network_flush	(void);
void 		ggl_network_kill	(void);
char *		ggl_network_local_IP	(char *	ip);
Glist *		ggl_network_socket_list	(void);
int		ggl_network_send	(int	obj_id,
					 void *	data,
					 int 	size_data);
void		ggl_network_finalize	(GglNetwork *	network);
void		ggl_network_dispose	(GglNetwork *	network);
					
#ifdef __cplusplus
      }
#endif /* __cplusplus */

#endif /* __GGLNETWORK_H__ */
