/* GGL - GPUL Game Library
 * Copyright (C) 1998 G.P.U.L. (Group of programmers and users of Linux)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <ggl/gglcolor.h>
#include <stdlib.h>

void ggl_color_init(GglColor *color, GglVisual *visual,int r, int g, int b)
{
    ggi_color ggicolor={r,g,b,0};
    
    color-> id=GGLCOLOR;
    color-> color=ggiMapColor(visual->visual,&ggicolor);
    color-> visual=visual;
}

GglColor* ggl_color_new(GglVisual *visual,int r, int g, int b)
{
    GglColor *color=(GglColor*)malloc(sizeof(GglColor));
    ggl_base_set_size(GGL_BASE(color),sizeof(GglColor));

    ggl_color_init(color,visual,r,g,b);

    return color;
}

void ggl_color_finalize(GglColor *color)
{
}

void ggl_color_dispose(GglColor *color)
{
  free(color);
}

void            ggl_color_components    (GglColor *color,
                                         int *r,
                                         int *g,
                                         int *b)
{
    ggi_color ggicolor;
    ggiUnmapPixel(color->visual->visual, color->color, &ggicolor);
    *r=ggicolor.r;
    *g=ggicolor.g;
    *b=ggicolor.b;
}
